
/******************************************************************************
* MODULE     : tuple.cpp
* DESCRIPTION: Syntactic tuple type constructor
* COPYRIGHT  : (C) 2006  Joris van der Hoeven
*******************************************************************************
* This software falls under the GNU general public license and comes WITHOUT
* ANY WARRANTY WHATSOEVER. See the file $TEXMACS_PATH/LICENSE for more details.
* If you don't have this file, write to the Free Software Foundation, Inc.,
* 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
******************************************************************************/

#include "tuple.hpp"
namespace mmx {

void
tuple_type_info (nat& id, bool& mode) {
  static table<nat,nat> t (0);
  if (mode == false) {
    mode= t->contains (id);
    id= t[id];
  }
  else {
    nat new_id= new_type_id ();
    t (new_id)= id;
    id= new_id;
  }
}

} // namespace mmx
