AC_DEFUN([AM_PATH_GMP],
[
    AC_MSG_CHECKING([whether gmp library is installed])
    AH_TEMPLATE([HAVE_GMP],[Define if you have the gmp library])
    LIBS="$LIBS -lgmp -lm"
    AC_TRY_LINK(
        [#include <gmp.h>],
        [__gmp_version;],
        [AC_DEFINE([HAVE_GMP],[])],
        AC_MSG_RESULT([no]);AC_MSG_ERROR([missing library: gmp]))
    AC_MSG_RESULT([yes])
])
