
/******************************************************************************
* MODULE     : table_meta.hpp
* DESCRIPTION: Categorial meta properties of tables
* COPYRIGHT  : (C) 2004  Joris van der Hoeven
*******************************************************************************
* This software falls under the GNU general public license and comes WITHOUT
* ANY WARRANTY WHATSOEVER. See the file $TEXMACS_PATH/LICENSE for more details.
* If you don't have this file, write to the Free Software Foundation, Inc.,
* 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
******************************************************************************/

#ifndef __MMX_TABLE_META_HPP
#define __MMX_TABLE_META_HPP
#include "table.hpp"
#include "category_meta.hpp"
namespace mmx {
#define TMPL template<typename C, typename T>
#define Table table<C,T>
#define META_TMPL TMPL
#define META_TPNM typename
#define META_TYPE Table

#define META_COND has<C,ring_cat>
HAS_RING()
#undef META_COND

#define META_COND has<C,div_op>
HAS(div_op)
#undef META_COND

#define META_COND has<C,ordering_cat>
HAS_ORDERING()
#undef META_COND

#undef META_TYPE
#undef META_TPNM
#undef META_TMPL
#undef Table
#undef TMPL
}
#endif // __MMX_TABLE_META_HPP
