
/******************************************************************************
* MODULE     : string_io.cpp
* DESCRIPTION: Input/output for strings
* COPYRIGHT  : (C) 2000  Joris van der Hoeven
*******************************************************************************
* This software falls under the GNU general public license and comes WITHOUT
* ANY WARRANTY WHATSOEVER. See the file $TEXMACS_PATH/LICENSE for more details.
* If you don't have this file, write to the Free Software Foundation, Inc.,
* 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
******************************************************************************/

#include "string.hpp"
#include <stdio.h>
#include <string.h>
namespace mmx {

ostream&
operator << (ostream& out, const string& s) {
  nat i, n=N(s);
  for (i=0; i<n; i++) out << s[i];
  return out;
}

} // namespace mmx
