
/******************************************************************************
* MODULE     : integer_meta.hpp
* DESCRIPTION: Categorial meta properties of integers
* COPYRIGHT  : (C) 2004  Joris van der Hoeven
*******************************************************************************
* This software falls under the GNU general public license and comes WITHOUT
* ANY WARRANTY WHATSOEVER. See the file $TEXMACS_PATH/LICENSE for more details.
* If you don't have this file, write to the Free Software Foundation, Inc.,
* 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
******************************************************************************/

#ifndef __MMX_INTEGER_META_HPP
#define __MMX_INTEGER_META_HPP
#include "integer.hpp"
#include "category_meta.hpp"
namespace mmx {
#define META_TMPL STMPL
#define META_TPNM
#define META_TYPE integer
#define META_COND always

HAS_RING()
HAS_ORDERING()

#undef META_COND
#undef META_TYPE
#undef META_TPNM
#undef META_TMPL
}
#endif // __MMX_INTEGER_META_HPP
